Leetcode Two Sum


Given an array of integers, return indices

You may assume that each input would have exactly one solution, and you may not use the same

Example:


Given nums = [2, 7, 11, 15], target = 9, Because nums[0] + nums[1] = 2 + 7 = 9, return [0, 1].



思路:

用一个HashMap存储元素。

以【2,7,11,15】 target=9为例。从2开始扫描整个数组,差值9-2=7,此时7 不在HashMap中,就把2和2的下标0添加到HashMap中。此时HashMap中的元素为【(2,0)】。

下一步扫描到7,差值9-7=2,发现2已经在HashMap中,就直接返回2的下标0 和7的下标1。

整个算法的时间复杂度为O(n),就是扫描一遍数组的时间。

再以【3,3】 target = 6为例。首先扫描3,差值为6-3=3。此时3不在HashMap中,就把(3,0)添加到HashMap中。然后扫描第二个3,差值6-3=3,发现3在HashMap中,则直接返回(0,1)。

总结:

  • 如果target与当前值的差值不在HashMap中,则将当前值与下标存放在HashMap里。注意,值是key,下标是value
  • 如果target与当前值的差值在HashMap中,则返回结果。
class Solution {
public int[] twoSum(int[] nums, int target) {
HashMap<Integer, Integer> map = new HashMap<>();
for(int i = 0; i < nums.length; i++) {
int diff = target - nums[i];
if(map.containsKey(diff)) {
return new int[] {map.get(diff), i};
}
map.put(nums[i], i);
}
throw new IllegalArgumentException("No two sum solution");
}

}

注:学渣心里苦,不要学楼主,平时不努力,考试二百五,哭~